
# I guess convert should be taught about non-suse distros as well.

def convert(_typed, src_project):
    typed = _typed.lower()

    if typed in ["10.1"]:
        result = "openSUSE_10.1"
    elif typed in ["10.2"]:
        result = "openSUSE_10.2"
    elif typed in ["10.3"]:
        result = "openSUSE_10.3"
    elif typed in ["11.0"]:
        result = "openSUSE_11.0"

    # enterprise disties
    elif typed in ["sles9", "sle9", "sles_9", "sle_9"]:
        result = "SLES_9"
    elif typed in ["sles10", "sled10", "sle10", "sles_10", "sled_10", "sle_10"]:
        result = "SLE_10"

    # factory and its many names
    elif typed in ["factory", "stable"]:
        factory_platforms = {
            "mozilla": "SUSE_Factory",
            "mozilla:beta": "SUSE_Factory",
            "mozilla:legacy": "SUSE_Factory",
            "openSUSE:Factory": "standard",
            # This is, of course, totally wrong.
            # We should probably use some sort of hueristic instead.
            "home:maw:branches:home:chrismrivera:branches:openSUSE:Factory": "standard"
            }
        try:
            result = factory_platforms[src_project]
        except KeyError:
            result = "openSUSE_Factory"
            pass
    # future disties
    elif typed in ["11.1"]:
        result = "openSUSE_11.1"
    elif typed in ["11.2"]:
        result = "openSUSE_11.2"
    elif typed in ["sles11", "sled11", "sle11", "sles_11", "sled_11", "sle_11"]:
        result = "SLE_11"
    else:
        result = _typed
        pass
    
    return result
