#def standards():
#    print "oh no"
#    pass

import bugzilla

# This is should know more about the different sections of .spec files
def standard_speclint_gnome(package, lines):

    bugzillae = bugzilla.bugzillas()
    
    # check for unapplied patches
    patches = {}

    for i in range(0, len(lines)):
        line = lines[i]
        if line.startswith("Patch"):
            patchno, patch = line.split()
            patchno = patchno.rstrip(':')
            patchno = patchno.lower()
            if patchno == "patch":
                patchno = "patch0"
                pass
            patches[patchno] = [patch]

            # is the previous line commented?
            commented = False
            if i == 0: # for the unlikely case that the first line is a patch declaration
                patches[patchno].append('uncommented')
                pass
            if lines[i - 1].startswith('#'):
                patches[patchno].append('commented')
                commented = True
                pass

            # if the previous line is commented, does it conform to our comment specification?
            if commented == True:
                cline = lines[i - 1]
                print "cline is %s" % cline
                cline = cline.strip("# ")
                cline_elements = cline.split()

                try:
                    patch_type = cline_elements[0]
                except IndexError:
                    print "Empty comment."
                    # So that split will not fail below, but also won't return
                    # a 3-element list
                    patch_type = ""
                    pass
                try:
                    patch_name = cline_elements[1]
                except IndexError:
                    print "Nearly empty comment."
                    patch_name = None
                    pass

                # Is the patch tagged?
                patch_type_elements = patch_type.split('-')
                cline_properly_tagged = False
                if len(patch_type_elements) != 3:
                    print "Too many or too few parts to the initial patch tag"
                    print "It should be 'PATCH-{FIX|FEATURE}-{OPENSUSE|UPSTREAM}'"
                    print ""
                else:
                    if patch_type_elements[0] != "PATCH":
                        print "%s doesn't start with PATCH-" % cline
                        pass
                    elif patch_type_elements[1] != "FIX" and patch_type_elements[1] != "FEATURE":
                        print "%s doesn't say whether it's a FIX or a FEATURE" % cline
                        print "!!! %s !!!" % patch_type_elements[1]
                        pass
                    elif patch_type_elements[2] != "OPENSUSE" and patch_type_elements[2] != "UPSTREAM":
                        print "%s doesn't say whether it's OPENSUSE or UPSTREAM" % cline
                        pass
                    else:
                        cline_properly_tagged = True
                        pass
                    pass
                if cline_properly_tagged == True:
                    patches[patchno].append("properly tagged")
                else:
                    patches[patchno].append("improperly tagged")
                    pass

                # Does the comment refer to an actual patch?  (needs work)
                if patch != patch_name:
                    patches[patchno].append("erroneous reference")
                    print "Your comment is claims to pertain to %s but it preceeds %s!" % \
                          (patch_name, patch)
                    pass

                # Does the comment refer to any bugs?
                bugno_count = 0
                for element in cline_elements:
                    for bz in bugzillae:
                        if element.startswith(bz):
                            bugno_count += 1
                            pass
                        pass
                    pass
                if bugno_count == 0:
                    patches[patchno].append("has no bug numbers")
                else:
                    patches[patchno].append("has bug numbers")
                    pass
                pass
            pass

        # Check which patches are actually being applied
        if line.startswith("%patch"):
            patch = line.split()[0] # we don't really care about patchlevels (or do we?)
            if patch == "%patch":
                patch = "%patch0"
            patch = patch.strip('%')
            if patch in patches:
                ### print "appending stuff"
                patches[patch].append('applied')
                pass
            pass
        pass

    applied_count = 0
    unapplied_count = 0
    commented_count = 0
    uncommented_count = 0
    tagged_count = 0
    untagged_count = 0
    # These are to count patches that have associated bugzilla (etc) numbers, not the
    # actual number of bugs, which we don't necessarily care about
    bugno_count = 0
    no_bugno_count = 0
    erroneous_reference_count = 0

    for key in patches.keys():
        ### print "%s -> %s" % (key, patches[key][0])
        if 'applied' in patches[key]:
            applied_count += 1
            print "%s is applied" % patches[key][0]
        else:
            unapplied_count += 1
            print "%s is not applied" % patches[key][0]
            pass

        if 'commented' in patches[key]:
            commented_count += 1
            print "%s is commented" % patches[key][0]
        else:
            uncommented_count += 1
            print "%s is uncommented" % patches[key][0]
            pass

        if "properly tagged" in patches[key]:
            tagged_count += 1
            # print "%s is properly tagged"
        else:
            untagged_count += 1
            # print "%s is improperly tagged"
            pass

        if "has bug numbers" in patches[key]:
            bugno_count += 1
        else:
            no_bugno_count += 1
            pass

        if "erroneous reference" in patches[key]:
            erroneous_reference_count += 1
            pass
        pass

    print "Summary:"
    print "\t%d patches listed in the .spec" % len(patches.keys())
    print ""
    print "\t%d applied patch(es)" % applied_count
    print "\t%d unapplied patch(es)" % unapplied_count
    print ""
    print "\t%d commented patch(es)" % commented_count
    print "\t%d uncommented patch(es)" % uncommented_count
    print ""
    print "\t%d properly tagged patch(es)" % tagged_count
    print "\t%d improperly tagged patch(es)" % untagged_count
    print ""
    print "\t%d patch(es) with associated bug numbers" % bugno_count
    print "\t%d patch(es) with no associated bug numbers" % no_bugno_count
    print ""
    print "\t%d erroneous reference(s) in patch comments" % erroneous_reference_count
    pass

def standard_speclint_mozilla(package):
    print "unimplemented"
    pass

def spec_standards():
    spec_standards = {"gnome" : standard_speclint_gnome,
                      "mozilla" : standard_speclint_mozilla}
    return spec_standards
    

def get_spec_standard(name):
    stds = spec_standards()
    
    if not name:
        print "Defaulting to the gnome .spec standard"
        return stds['gnome']

    try:
        func = stds[name]
    except KeyError:
        print "ERROR: spec standard %s unknown" % name
        print "Known standards:"
        stds = stds.keys()
        stds.sort()
        for std in stds:
            print "\t%s" % std
        return 1
    return func

def standard_patchlint_mozilla(package, patchname):
    print "standard_patchlint_mozilla unimplemented"
    pass

# To add a new patch naming standard, write a function:
# * I'm calling them patchlint_$std for the time being (eg,
#   patchlint_gnome)
# * The function takes two arguments: a package name and a filename
#
# Then update the patch_standards dict.

def standard_patchlint_gnome(package, patchname):
    import os, os.path
    print "\t%s:" % patchname
    ### print "we'll inspect %s later..." % patchname
    base, suffix = os.path.splitext(patchname)
    elements = base.split('-')
    
    deviation_count = 0

    # Does it end in .patch?
    if suffix != '.patch':
        deviation_count += 1
        print "\t\tdoes not end in '.patch'"
        
    # Does it end in .dif?  OMG
    if suffix == '.dif':
        deviation_count += 1
        print "\t\t%s ends in '.dif'.  Oh the humanity!" % patchname
        
    # Does it start with $package-?
    if not patchname.startswith("%s-" % package):
        deviation_count += 1
        print "\t\tdoesn't match the package's name"

    # Does it include any bug info?

    # FIXME: what else belongs in this list?
    bugzillae = ["bnc",  # bugzilla.novell.com
                 "bgo",  # bugzilla.gnome.org
                 "bmo",  # bugzilla.mozilla.org
                 "bfo",  # bugs.freedesktop.org
                 "bln",  # bugs.launchpad.net
                 "brc",  # bugzilla.redhat.com
                 "fate", # fate
                 "cve",  # cve.mitre.org number (not strictly bugzilla)
                 ]
    bug_number_count = 0
    for element in elements:
        for bz in bugzillae:
            if element.startswith(bz):
                bug_number_count += 1
                ### print "\t\tincludes a bug number.  good."
                pass
            pass
        pass
    if bug_number_count == 0:
        deviation_count += 1
        print "\t\tno bugzilla information"
        pass
    
    if deviation_count == 0:
        print "\t\tlooks good"
        pass
    
    print ""
    pass

def patch_standards():
    patch_standards = {"gnome" : standard_patchlint_gnome,
                       "mozilla" : standard_patchlint_mozilla}
    return patch_standards

def get_patch_standard(name):
    stds = patch_standards()
    
    if not name:
        print "Defaulting to the gnome .spec standard"
        return stds['gnome']

    try:
        func = stds[name]
    except KeyError:
        print "Error: Patch standard %s unknown" % name
        print "Known standards:"
        stds = stds.keys()
        stds.sort()
        for std in stds:
            print "\t%s" % std
            pass
        return 1
    
    return func
