import os

@cmdln.option('--standard', metavar='STANDARD',
              help="the package standard we want to apply (defaults to 'base')")

def do_createspec(self, subcmd, opts, package):
    """${cmd_name}: Create a template spec file for the given package

    Examples:
       createspec mypackage --standard=base

    ${cmd_usage}
    ${cmd_option_list}
    """

    if not opts.standard:
        print "Defaulting to the base .spec standard"
        opts.standard = "base"
    
    standard = opts.standard
    

    osc_plugins_templatedir = "/usr/share/osc-plugins-gnome/templates"

    if standard == "gnome":
        os.system ("cp -p " + osc_plugins_templatedir + "/template-gnome.spec " + package + ".spec")
    elif standard == "kde":
        os.system ("cp -p " + osc_plugins_templatedir + "/template-kde.spec " + package + ".spec")
    elif standard == "python":
        os.system ("cp -p " + osc_plugins_templatedir + "/template-python.spec " + package + ".spec")
    else:
        os.system ("cp -p " + osc_plugins_templatedir + "/template-base.spec " + package + ".spec")
