def clean_link (self, masterproject, slaveproject, package, dry_run, confirm):
    import re

    if confirm:
        confirm_exp = re.compile ("[Yy]([eE][sE]){0,1}")
        print ""
        confirm_input = raw_input ("    Link %s/%s to %s/%s? (y/n): " % (slaveproject, package, masterproject, package))
        if not confirm_exp.match (confirm_input): 
            return

    if not dry_run:
        if (confirm):
            print "Linking packages",
        else:
            print " - Linking packages",
        delete_package (conf.config['apiurl'], slaveproject, package)
        link_pac (masterproject, package, slaveproject, package)

def version_changed (self, rdiff):
    import re

    old_exp = re.compile ("-Version:\s*(.*)")
    new_exp = re.compile ("\+Version:\s*(.*)")

    old_result = old_exp.search (rdiff)
    new_result = new_exp.search (rdiff)

    # FIXME handle multiple spec files
    # FIXME ensure the newer version is in the master project spec file
    if old_result != None and old_result.group (1) < new_result.group (1):
        print "%s vs %s -" % (old_result.group (1), new_result.group (1)), 
        return True

    return False

# it might make sense to add an option to attempt to merge patches.
@cmdln.option('-n', '--newer', action='store_true',
              help='update if version is newer as well')
@cmdln.option('-f', '--diff', action='store_true',
              help='display diff')
@cmdln.option('-d', '--dry-run', action='store_true',
              help='dry run, do not link packages')
@cmdln.option('-c', '--confirm', action='store_true',
              help='confirm each link action')

def do_linksame(self, subcmd, opts, *args):
    """${cmd_name}: Link packages in one repo to another if they are the same
    
    Examples:
      linksame openSUSE:Factory GNOME:UNSTABLE
    
    usage: 
      osc linksame MASTERPRJ SLAVEPRJ [PACKAGES...]
    
    ${cmd_option_list}"""

    from oscpluginsgnome import rdiff

    args = slash_split(args)

    if not args or len(args) < 2:
        print >>sys.stderr, 'Incorrect number of argument.'
        self.do_help([None, 'linksame'])
        return 2
    
    masterproject = args[0]
    slaveproject = args[1]
    if len(args) > 2:
        packages = args[2:]
    else:
        packages = meta_get_packagelist(conf.config['apiurl'], slaveproject)
        
    for package in packages:
        print "*** Checking %s: " % package,

        try:
            rd = pretty_diff(conf.config['apiurl'],
                                slaveproject, package, None,
                                masterproject, package, None)
        except:
            print "Unable to diff (no such package in master or slave?)" 
            continue

        if rdiff.unchanged(rd):
            print "Identical",
            self.clean_link (masterproject, slaveproject, package, opts.dry_run, opts.confirm)
        elif self.version_changed (rd) == True:
            print "Newer version in destination",
            if (opts.diff):
                print "'" + rd + "'"
            self.clean_link (masterproject, slaveproject, package, opts.dry_run, opts.confirm)
        else:
            print "Differences, not linking packages",
            if (opts.diff):
                print "'" + rd + "'"

        print ""

        pass

