# First cut at a speclinting extension.

@cmdln.option('--standard', metavar='STANDARD',
              help="the patch standard we want to apply (defaults to 'gnome'")
@cmdln.option('--package', metavar='PACKAGE',
              help='only patches for this package')
@cmdln.option('--local', action='store_true',
              help="Look at a .spec file in the current working directory")


def do_speclint(self, subcmd, opts, project=None):
    # this description is horrible
    """${cmd_name}: Display a summary of a .spec file's problems within a package or repository

    Examples:
       speclint GNOME:UNSTABLE
       speclint --package=abiword GNOME:UNSTABLE
       speclint --package=abiword --standard=gnome GNOME:UNSTABLE
       
    ${cmd_usage}
    ${cmd_option_list}
    """

    from oscpluginsgnome import standards as stds
    # import oscpluginsgnome.stds
    from oscpluginsgnome import bugzilla as bz
    
    func = stds.get_spec_standard(opts.standard)

    if opts.local:
        # f = None
        spec = None
        if project:
            print "warning: --local was set, so the project (%s) is ignored" % project
        print "think globally, act locally!"
        if opts.package:
            spec = "%s.spec" % opts.package
            lines = open(spec).readlines()

        else:
            for f in os.listdir('.'):
                if f.endswith(".spec"):
                    spec = f
                    break
                pass
            print "spec is %s" % spec
            lines = open(spec).readlines()
            pass
        func(spec.rstrip(".spec"), lines)
    else:
        if project == None:
            print "Error: no project specified!"
            return 0
        else:
            packages = meta_get_packagelist(conf.config['apiurl'], project)
            for package in packages:
                if opts.package and package != opts.package:
                    continue
                
                print "speccing out %s's spec" % package
                
                files = meta_get_filelist(conf.config['apiurl'], project, package)
                
                for file in files:
                    extension = os.path.splitext(file)[1]
                    if extension != ".spec":
                        continue
                    # FIXME: This should go in a temporary directory.
                    target = "%s-downloaded" % file
                    get_source_file(conf.config['apiurl'], project, package, file, targetfilename=target)
                    lines = open(target).readlines()
                    os.unlink(target)
                    func(package, lines)
                    

