# FIXME: The cached output stuff is now duplicated in osc-diffreq.py and
# osc-submitreq.py.  It should go elsewhere.

@cmdln.alias("diffreq") # for backward compatibility -- it used to be called diffreq
@cmdln.alias("sd")
@cmdln.alias("dr")
def do_submitreqdiff(self, subcmd, opts, reqid):
    """${cmd_name}: An easier to use wrapper around `osc submitreq -d <id>'

    Example:
        diffreq 123
   
    Also, note that you'll need to do `mkdir -p ~/.osc/cache/submitreq-diffs'.

    ${cmd_usage}
    ${cmd_option_list}
    """

    import commands
    import os
    import os.path
    import oscpluginsgnome.cache
    
    command = 'submitreqdiff'
    
    cache_dir = oscpluginsgnome.cache.get_cache_dir(command)

    cached_output = "%s/%s" % (cache_dir, reqid)

    if reqid in os.listdir(cache_dir):
        f = open(cached_output)
        lines = f.readlines()
        for line in lines:
            print line.strip('\n')
            pass
        return
    
    cmd = "osc submitreq show -d %s" % reqid
    status, output = commands.getstatusoutput(cmd)
    
    f = open(cached_output, "w")
    f.write(output)
    f.flush()
    f.close()
    
    print output
    
